/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "coms.h"

#include <sstream>

#include <cstdlib>

#include "avatar_stats.h"
#include "fed2.h"
#include "init.h"
#include "login_code.h"
#include "macro.h"
#include "main.h"
#include "new_account.h"
#include "new_ac_code.h"
#include "server_parser.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------

Coms::Coms()
{
	login = 0;
	new_account = 0;
	status = OFFLINE;
	parser = new ServerParser("");
}


void	Coms::Connected()
{
	static std::string	connect("Connected");
	MainForm->OutputText(connect);
	MainForm->StatusBar->Panels->Items[0]->Text = connect.c_str();
}

void	Coms::Logon()
{
	status = LOGON;
	delete login;
	login = new Login;
}

void	Coms::NewAccountAvatar()
{
	status = NEW_ACCOUNT;
	delete new_account;
	new_account = new NewAccount;
}

void	Coms::Start()
{
	static const std::string	init_string("<?xml version=\"1.0\"?>\n");
	MainForm->Send(init_string);
	std::ostringstream buffer;
	buffer << "<c-fedterm version='" << MainForm->Version() << "'>\n";
	MainForm->Send(buffer.str().c_str());
	delete login;
	login = 0;
	delete new_account;
	new_account = 0;
	status = START;
}

void	Coms::ServerText(const char *text)
{
	static std::string	buffer;

	buffer += text;
	std::string::size_type	index;
	std::string	line;
	for(;;)
	{
		index = buffer.find('\n');
		if(index == std::string::npos)
			return;
		if(index == 0)
		{
			buffer.erase(0,1);
			line = " ";
		}
		else
		{
			line = buffer.substr(0,index);
			buffer.erase(0,index);
		}

		switch(status)
		{
			case LOGON:
				if(login->ProcessText(line) == Login::FINISHED)
					Start();
				break;
			case NEW_ACCOUNT:
				if(new_account->ProcessText(line) == NewAccount::FINISHED)
					Start();
				break;
			case START:	SwitchToXML(line);		break;
			case XML:  	parser->Parse(line);		break;
		}
	}
}

void	Coms::SwitchToXML(const std::string& line)
{
	if(line[0] == '<')
	{
		status = XML;
		MainForm->Send("look\n");
		Fed2::macro->Send(1);
	}
	else
		MainForm->OutputText(line);
}


