/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#ifndef FRIENDSCODE_H
#define FRIENDSCODE_H

#include <bitset>
#include <fstream>
#include <list>
#include <string>

class	Friends
{
public:
	enum
	{
		GROUNDHOG, COMMANDER, CAPTAIN, ADVENTURER, MERCHANT, TRADER, INDUSTRIALIST,
		MANUFACTURER, FINANCIER, FOUNDER, ENGINEER, MOGUL, TECHNOCRAT, MAGNATE,
		PLUTOCRAT, SYNDICRAT,
		MAX_RANK
	};		// ranks

private:
	std::list<std::string>	friends_list;
	std::bitset<MAX_RANK>	ranks;
	bool							audio;

	std::string&	Normalise(const std::string& name);
	void	Clear();
	void	SoundAudio();

public:
	Friends()								{ audio = false;				}
	~Friends()	{	}

	bool	IsFriend(int which_rank)	{ return(ranks.test(which_rank));	}
	bool	IsFriend(const std::string& name);

	void	AddFriend(const std::string& name);
	void	AddRank(int which_rank)		{ ranks.set(which_rank);	}
	void	AddRanks(unsigned long flags);
	void	GetInfo();
	void	Process(int rank,const std::string& name,bool enter);
	void	SetAudio()						{ audio = true;				}
	void	UpdateForm();
	void	Write(std::ofstream& file);
};

#endif
