/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#ifndef LOGINCODE_H
#define LOGINCODE_H

#include <string>

#include "account_rec.h"

class	Login
{
public:
	enum	{ MORE_TO_COME, FINISHED	};

private:
	enum	{ ACCOUNT_ID, PASSWORD, ALL_SENT, RETRY	};

	AccountRec	*account;		// the current account
	int			status;

	int	AccountID(const std::string& line);
	int	Password(const std::string& line);
	int	Start(const std::string& line);

	void	UpdateLogonForm();
	void	UpdateLogonRecord(const AccountRec *rec);

public:
	Login();
	~Login();

	int	ProcessText(std::string& line);

	bool	Previous();

	void	Next();
	void	Connect(bool has_changed);
	void	DeleteCurrent();
};

#endif
