/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "macro.h"

#include "fed2.h"
#include "init.h"
#include "macroform.h"
#include "macro_rec.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------

const int	Macro::MAX_FKEYS;

Macro::Macro()
{
	for(int count = 0;count < MAX_FKEYS;count++) // make sure we crash if we use zero
		recs[count] = 0;
	current = 0;
}

Macro::~Macro()
{
	for(int count = 1;count < MAX_FKEYS;count++)
		delete recs[count];
}


void	Macro::Add(int index,MacroRec *rec)
{
	if((index < 1) || (index >= MAX_FKEYS))
	{
		delete rec;
		return;
	}

	if(recs[index] != 0)
		delete recs[index];
	recs[index] = rec;
}

void	Macro::Display(int index)
{
	if((index > 0) && (index < MAX_FKEYS))
	{
		current = index;
		MacroBox->UpdateCurrent(index);
		if(recs[index] != 0)
			recs[index]->Display();
		else
			MacroBox->FKeyMemo->Clear();
	}
}

void	Macro::Process()
{
	MacroBox->SetMacro(this);
	MacroBox->Visible = true;
}

void	Macro::Send(int index)
{
	if((index < 1) || (index >= MAX_FKEYS) || (recs[index] == 0))
		return;
	else
		recs[index]->Send();
}

void	Macro::Transfer(int index,TMemo *memo)
{
	if((index < 1) || (index >= MAX_FKEYS) || (recs[index] == 0))
		return;
	else
		recs[index]->Transfer(memo);
}

void	Macro::Update(int index,TMemo *memo)
{
	if((index < 1) || (index >= MAX_FKEYS))
		return;
	else
	{
		if(recs[index] == 0)
			recs[index] = new  MacroRec;
		recs[index]->Update(memo);
		Fed2::init->Write();
	}
}

void	Macro::Write(std::ofstream& file)
{
	for(int count = 1;count < MAX_FKEYS;count++)
	{
		if(recs[count] != 0)
		{
			file << "   <macro key='" << count << "'>\n";
			recs[count]->Write(file);
			file << "   </macro>\n\n";
		}
	}
}




