/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#ifndef MAIN_H
#define MAIN_H

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <ScktComp.hpp>
#include <Grids.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
#include <Graphics.hpp>

#include <string>

#include <dir.h>

class TMainForm : public TForm
{
__published:	// IDE-managed Components
	TMainMenu *MainMenu;
	TMenuItem *FileItem;
	TPanel *MainLeftPanel;
	TPanel *MainRightPanel;
	TPageControl *MainNotebook;
	TTabSheet *MainTab;
	TPanel *LeftPanel;
	TPageControl *PlayersNotebook;
	TTabSheet *PlayersTab;
	TListBox *PlayerListBox;
	TClientSocket *CliSocket;
	TMenuItem *DisplayClientStreamItem;
	TMenuItem *ConnectItem;
	TMenuItem *LogonItem;
	TMenuItem *DisplayServerStreamItem;
	TTabSheet *MapTab;
	TPanel *Panel1;
	TPanel *ImagePanel;
	TPanel *ContentPanel;
	TPageControl *ContentsNotebook;
	TTabSheet *LocTab;
	TListBox *LocListBox;
	TTabSheet *StoryTab;
	TTabSheet *ScrollTab;
	TMemo *ScrollBackMemo;
	TMemo *StoryMemo;
	TDrawGrid *DetailGrid;
	TDrawGrid *MapGrid;
	TPanel *MapInfoPanel;
	TPanel *MapTextpanel;
	TMemo *MapMemo;
	TMenuItem *Options2;
	TPanel *MoveBtnPanel;
	TSpeedButton *NMoveBtn;
	TSpeedButton *WMoveBtn;
	TSpeedButton *EMoveBtn;
	TSpeedButton *SMoveBtn;
	TSpeedButton *NEMoveBtn;
	TSpeedButton *SEMoveBtn;
	TSpeedButton *SWMoveBtn;
	TSpeedButton *NWMoveBtn;
	TBitBtn *UpBtn;
	TBitBtn *DownBtn;
	TPanel *MapRepeaterPanel;
	TMemo *MapRepeater;
	TSpeedButton *BoardBtn;
	TMenuItem *ExitItem;
	TMenuItem *NewAccountAvatarItem;
	TMenuItem *StartLoggingItem;
	TMenuItem *StopLoggingItem;
	TMenuItem *N1;
	TBitBtn *CommandBtn;
	TOpenDialog *OpenDialog;
	TMenuItem *AutoLogItem;
	TMenuItem *N2;
	TMenuItem *SaveScreenItem;
	TMenuItem *Edit1;
	TMenuItem *CopyItem;
	TMenuItem *PasteItem;
	TMenuItem *SelectAllItem;
	TMenuItem *N3;
	TMenuItem *LogOffItem;
	TStatusBar *StatusBar;
	TMenuItem *N4;
	TMenuItem *ColorItem;
	TMenuItem *FontsItem;
	TMenuItem *N5;
	TMenuItem *TextAlertItem;
	TMenuItem *BufferSizeItem;
	TMenuItem *BlankLinesItem;
	TColorDialog *ColorDialog;
	TFontDialog *FontDialog;
	TMenuItem *FKeyStartUpItem;
	TPopupMenu *PlayerPopup;
	TMenuItem *ExamineItem;
	TMenuItem *HugItem;
	TMenuItem *KissItem;
	TMenuItem *SpynetReport;
	TMenuItem *N6;
	TMenuItem *N7;
	TMenuItem *Help1;
	TMenuItem *MapsItem;
	TMenuItem *ManualsItem;
	TMenuItem *ExtrasItem;
	TMenuItem *FeedbackItem;
	TMenuItem *N8;
	TMenuItem *AboutItem;
	TMenuItem *QuickStartItem;
	TMenuItem *N9;
	TMenuItem *DumptoScrollItem;
	TMenuItem *FedTermManual1;
	TMenuItem *N10;
	TSplitter *Splitter2;
	TSplitter *Splitter3;
	TPanel *StatsPanel;
	TPanel *Panel3;
	TPanel *InputPanel;
	TMemo *InputEdit;
	TPanel *OutputPanel;
	TMemo *OutputEdit;
	TSplitter *MainSplitter;
	TPageControl *StatsNoteBook;
	TTabSheet *ScoreTab;
	TTabSheet *ShipTab;
	TPanel *ScorePanel;
	TPanel *ShipPanel;
	TPanel *Panel2;
	TImage *ScoreImage;
	TLabel *NameLabel;
	TStringGrid *StatsGrid;
	TLabel *RankLabel;
	TGroupBox *StatBox;
	TProgressBar *StatBar;
	TMenuItem *StatsItem;
	TPanel *Panel4;
	TImage *ShipImage;
	TLabel *ClassLabel;
	TStringGrid *ShipGrid;
	TGroupBox *ShipBox;
	TProgressBar *ShipBar;
	TPanel *TwinkPanel;
	TPanel *T0;
	TPanel *T1;
	TPanel *T2;
	TPanel *T3;
	TPanel *T4;
	TPanel *T5;
	TPanel *T6;
	TPanel *T7;
	TPanel *T8;
	TPanel *T9;
	TTimer *TwinkleTimer;
	TMenuItem *LightsItem;
	TMenuItem *TightBeamItem;
	TTabSheet *FriendsTab;
	TListBox *FriendsListBox;
	TMenuItem *Friendsitem;
	TMenuItem *VotingItem;
	TImage *MapImage;
	TMenuItem *Extras1;
	TMenuItem *N11;
	TMenuItem *SoundItem;
	TMenuItem *N12;
	TMenuItem *N13;
	TPageControl *TopNotebook;
	TTabSheet *ExSpTab;
	TTabSheet *ExchTab;
	TPanel *Panel5;
	TPanel *ExchPanel;
	TGroupBox *LastExchGroup;
	TGroupBox *GroupBox2;
	TPanel *LastCommodPanel;
	TLabel *CommodLabel2;
	TLabel *CommodLabel1;
	TLabel *CommodNameLabel;
	TPanel *Panel7;
	TImage *ExchImage;
	TTabSheet *PrivateTab;
	TPanel *Panel6;
	TPanel *TBNamePanel;
	TPanel *Panel9;
	TPanel *Panel10;
	TImage *TBImage;
	TPanel *Panel11;
	TMemo *TBMemo;
	TBitBtn *TBEndBtn;
	TListBox *HistoryListBox;
	TTimer *TickerTimer;
	TPanel *TickerPanel;
	TEdit *TickerEdit;
	TPanel *Panel8;
	TPanel *Panel12;
	TImage *SpynetImage;
	TPanel *Panel13;
	TPanel *SpynetNamePanel;
	TMemo *SpynetOutput;
	void __fastcall CliSocketConnect(TObject *Sender, TCustomWinSocket *Socket);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall CliSocketDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
	void __fastcall CliSocketRead(TObject *Sender, TCustomWinSocket *Socket);
	void __fastcall DisplayClientStreamItemClick(TObject *Sender);
	void __fastcall LogonItemClick(TObject *Sender);
	void __fastcall DisplayServerStreamItemClick(TObject *Sender);
	void __fastcall InputEditKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall MapGridDrawCell(TObject *Sender, int ACol, int ARow,
          TRect &Rect, TGridDrawState State);
	void __fastcall DetailGridDrawCell(TObject *Sender, int ACol, int ARow,
			 TRect &Rect, TGridDrawState State);
	void __fastcall DetailGridKeyUp(TObject *Sender, WORD &Key,
			 TShiftState Shift);
	void __fastcall MapGridKeyUp(TObject *Sender, WORD &Key,
			 TShiftState Shift);
	void __fastcall MoveBtnClick(TObject *Sender);
	void __fastcall UpBtnMouseUp(TObject *Sender, TMouseButton Button,
			 TShiftState Shift, int X, int Y);
	void __fastcall DownBtnMouseUp(TObject *Sender, TMouseButton Button,
			 TShiftState Shift, int X, int Y);
	void __fastcall MainNotebookChange(TObject *Sender);
	void __fastcall BoardBtnClick(TObject *Sender);
	void __fastcall ExitItemClick(TObject *Sender);
	void __fastcall MapMouseMove(TObject *Sender,TShiftState Shift, int X, int Y);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall NewAccountAvatarItemClick(TObject *Sender);
	void __fastcall CommandBtnClick(TObject *Sender);
	void __fastcall AutoLogItemClick(TObject *Sender);
	void __fastcall StartLoggingItemClick(TObject *Sender);
	void __fastcall StopLoggingItemClick(TObject *Sender);
	void __fastcall SaveScreenItemClick(TObject *Sender);
	void __fastcall CopyItemClick(TObject *Sender);
	void __fastcall PasteItemClick(TObject *Sender);
	void __fastcall SelectAllItemClick(TObject *Sender);
	void __fastcall InputEditEnter(TObject *Sender);
	void __fastcall InputEditExit(TObject *Sender);
	void __fastcall LogOffItemClick(TObject *Sender);
	void __fastcall FKeyStartUpItemClick(TObject *Sender);
	void __fastcall ColorItemClick(TObject *Sender);
	void __fastcall FontsItemClick(TObject *Sender);
	void __fastcall TextAlertItemClick(TObject *Sender);
	void __fastcall BufferSizeItemClick(TObject *Sender);
	void __fastcall BlankLinesItemClick(TObject *Sender);
	void __fastcall ExamineItemClick(TObject *Sender);
	void __fastcall HugItemClick(TObject *Sender);
	void __fastcall KissItemClick(TObject *Sender);
	void __fastcall SpynetReportClick(TObject *Sender);
	void __fastcall PlayerListBoxDblClick(TObject *Sender);
	void __fastcall ExtrasItemClick(TObject *Sender);
	void __fastcall ManualsItemClick(TObject *Sender);
	void __fastcall QuickStartItemClick(TObject *Sender);
	void __fastcall MapsItemClick(TObject *Sender);
	void __fastcall FeedbackItemClick(TObject *Sender);
	void __fastcall AboutItemClick(TObject *Sender);
	void __fastcall DumptoScrollItemClick(TObject *Sender);
	void __fastcall FedTermManual1Click(TObject *Sender);
	void __fastcall StatsItemClick(TObject *Sender);
	void __fastcall StatsGridClick(TObject *Sender);
	void __fastcall TwinkleTimerTimer(TObject *Sender);
	void __fastcall ShipGridClick(TObject *Sender);
	void __fastcall LightsItemClick(TObject *Sender);
	void __fastcall TightBeamItemClick(TObject *Sender);
	void __fastcall FriendsitemClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall VotingItemClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall SoundItemClick(TObject *Sender);
	void __fastcall LocListBoxDblClick(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall TopNotebookChange(TObject *Sender);
	void __fastcall TBEndBtnClick(TObject *Sender);
	void __fastcall TickerTimerTimer(TObject *Sender);
	void __fastcall HistoryListBoxDblClick(TObject *Sender);
	void __fastcall HistoryListBoxClick(TObject *Sender);
private:
	static const int ROW_COUNT;

	int	buffer_size;
	std::string	version;
	std::string	home_dir;
	std::string	avatar_name;
	std::string	server_name;
	TCustomWinSocket	*WinSocket;

	int	FindShipStat(const std::string& stat_name);
	int	FindStat(const std::string& stat_name);

	void	ClearAvatarEntry(int index);
	void	DisplayPlayerNumbers();

public:
	__fastcall TMainForm(TComponent* Owner);

	const std::string&	HomeDir()							{ return(home_dir);	}
	const std::string&	Version()							{ return(version);	}

	int	FindPlayer(const std::string& name);

	void	AddContents(const std::string& name);
	void	AddFriend(const std::string& name);
	void	AddPlayer(const std::string& name);
	void	ClearAvatarAKCredits();
	void	ClearAvatarHaulerCredits();
	void	ClearAvatarLoan();
	void	ClearAvatarMerchantCredits();
	void	ClearAvatarShipDisplay();
	void	ClearAvatarStatsDisplay();
	void	ClearAvatarTraderCredits();
	void	ClearPlayers();
	void	ClipTextBuffer(TMemo *memo);
	void	DeleteFriend(const std::string& name);
	void	DeletePlayer(const std::string& name);
	void	DisplayAvatarAKCredits(int ak);
	void	DisplayAvatarCash(const std::string&  amount);
	void	DisplayAvatarDexterity(int maximum,int current);
	void	DisplayAvatarHaulerCredits(int hc);
	void	DisplayAvatarIntelligence(int maximum,int current);
	void	DisplayAvatarLoan(const std::string&  amount);
	void	DisplayAvatarMerchantCredits(int merchant_pts);
	void	DisplayAvatarTraderCredits(int trader_pts);
	void	DisplayAvatarName(const std::string& name);
	void	DisplayAvatarRank(const std::string& rank);
	void	DisplayAvatarStamina(int maximum,int current);
	void	DisplayAvatarStrength(int maximum,int current);
	void	DisplayScoreStats();
	void	DisplayShipCargo(int maximum,int minimum);
	void	DisplayShipClass(const std::string& class_name);
	void	DisplayShipComputer(int maximum,int minimum);
	void	DisplayShipCustomsCert();
	void	DisplayShipEngines(int maximum,int minimum);
	void	DisplayShipFuel(int maximum,int minimum);
	void	DisplayShipHull(int maximum,int minimum);
	void	DisplayShipNavComp();
	void	DisplayShipShields(int maximum,int minimum);
	void	DisplayShipStats();
	void	Emote(const char *emotion);
	void	ExchangeTicker(const std::string& text);
	void	Logon(std::string& host,int port_num,std::string& pl_name);
	void	OutputDebug(const std::string& text) 			{ OutputDebug(text.c_str());	}
	void	OutputDebug(const char *text);
	void	OutputLoc(const std::string& text)				{ OutputLoc(text.c_str());	}
	void	OutputLoc(const char *text);
	void	OutputStory(const char *text);
	void	OutputText(const std::string& text,bool no_story = false)				{ OutputText(text.c_str(),no_story);	}
	void	OutputText(const char *text,bool no_story = false);
	void	RemoveContents(const std::string& name);
	void	Send(const std::string& text);
	void	SetBufferSize(int new_size);
	void	SetColour(TColor colour);
	void	SetFont(TFont *font);
	void	SetSpynetOutputToTop();
	void	SetStatsPanel(bool visible);
	void	ShuffleStatsDisplay();
	void	SocketOpenException();
	void	StatsSetUp();
	void	UpdateShipStatBox(const std::string& stat,int current,int maximum);
	void	UpdateStatBox(const std::string& stat,int current,int maximum);
};

//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------

#endif
