/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#ifndef NEWACCOUNT_H
#define NEWACCOUNT_H

//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Graphics.hpp>
//---------------------------------------------------------------------------

#include <string>

class NewAccount;

class TNewAccountForm : public TForm
{
__published:	// IDE-managed Components
	TPanel *Panel1;
	TGroupBox *Account;
	TGroupBox *GroupBox1;
	TGroupBox *GroupBox2;
	TLabel *Label1;
	TEdit *HostEdit;
	TLabel *Label2;
	TEdit *PortEdit;
	TLabel *Label3;
	TEdit *IDEdit;
	TLabel *Label4;
	TLabel *Label5;
	TCheckBox *NewAcCheck;
	TEdit *PwEdit;
	TEdit *PwConfEdit;
	TLabel *Label6;
	TEdit *EMailEdit;
	TLabel *Label7;
	TEdit *NameEdit;
	TEdit *RaceEdit;
	TLabel *Label8;
	TRadioGroup *GenderRadio;
	TGroupBox *GroupBox3;
	TLabel *Label9;
	TEdit *StrEdit;
	TEdit *DexEdit;
	TLabel *Label11;
	TLabel *Label10;
	TLabel *Label12;
	TEdit *StaEdit;
	TEdit *IntEdit;
	TGroupBox *GroupBox4;
	TEdit *UnusedEdit;
	TButton *CancelBtn;
	TButton *SendBtn;
	TUpDown *StrSpin;
	TUpDown *DexSpin;
	TUpDown *UpDown1;
	TUpDown *UpDown2;
	TPanel *ImagePanel;
	TImage *Image;
	TCheckBox *SavePwCheck;
	void __fastcall CancelBtnClick(TObject *Sender);
	void __fastcall SendBtnClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall StatChange(TObject *Sender, bool &AllowChange,
			 short NewValue, TUpDownDirection Direction);
private:
	enum	{ STR, STA, DEX, INT	};

	NewAccount	*new_account;
	bool			can_close;

	bool	CheckEMail();
	bool	CheckForASCII(const std::string& text) const;
	bool	CheckHost();
	bool	CheckID();
	bool	CheckName();
	bool	CheckPort();
	bool	CheckPassword();
	bool	CheckRace();
	bool	CheckUnused();
	bool	ConfirmPassword();

public:
	__fastcall TNewAccountForm(TComponent* Owner);

	void	ReplyTo(NewAccount *who)	{ new_account = who;	}

};

//---------------------------------------------------------------------------
extern PACKAGE TNewAccountForm *NewAccountForm;
//---------------------------------------------------------------------------

#endif
