/*-----------------------------------------------------------------------
			Copyright (c) Interactive Broadcasting 2005
	All Rights Reserved. No part of this software may be reproduced,
	transmitted, transcribed, stored in a retrieval system, or translated
	into any human or computer language, in any form or by any means,
	electronic, mechanical, magnetic, optical, manual or otherwise,
	without the express written permission of the copyright holder.
-----------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "tokens.h"

#include <cctype>

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------


const std::string& Tokens::operator[](int index) const
{
	static const std::string	error("index out of bounds");
	if((index < 0) || (index >= Size()))
		return(error);
	else
		return(token_array[index].second);
}

int	Tokens::Start(int index)
{
	if((index < 0) || (index >= Size()))
		return(-1);
	else
		return(token_array[index].first);
}

void	Tokens::Tokenize(const std::string& line,const char sep,int max_tokens)
{
	std::string	text(line);
	text += sep;

	token_array.clear();
	int	len = text.length();
	int	next_start = 0;
	for(int count = 0;count < len;count++)
	{
		if(text[count] == sep)
		{
			if(next_start == count)
				next_start++;
			else
			{
				std::pair<int,std::string> rec(next_start,text.substr(next_start,count - next_start));
				token_array.push_back(rec);
				if(Size() >= max_tokens)
					break;
				next_start = count + 1;
			}
		}
	}
}


