/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#ifndef XML_H
#define XML_H

#include <fstream>
#include <list>
#include <string>

struct AttribRec
{
	std::string	name;
	std::string	value;
};

typedef std::list<AttribRec>	AttribList;

class	XMLParser	// warning - this isn't a validating parser - it's very cut down
{
private:
	std::string		file_name;
	std::ifstream	file;

	std::string		element;
	AttribList		attrib_list;

protected:
	void	BuildElement(const std::string& line);
	void	BuildAttributes(const std::string& line);
	void	ProcessLine(const std::string& line);
	static std::string&	UnEscapeXML(std::string& text);


	virtual void	StartElement(const std::string& elem,const AttribList& attrib)	{	}
	virtual void	EndElement(const std::string& elem)										{	}
	virtual void	TextData(const std::string& text)										{	}

public:
	static std::string&	EscapeXML(const std::string&text);

	static int	FindNumAttrib(const AttribList& attrib,const std::string& name,int default_val);
	static bool	FindBoolAttrib(const AttribList& attrib,const std::string& name,bool default_val);
	static void	FindAttrib(const AttribList& attrib,const std::string& name,std::string& variable);

	XMLParser(const std::string& f_name);
	virtual	~XMLParser();

	bool	Parse();
	void	Parse(const std::string& line);
};

#endif
